package info.gomi.lisp.sdlisp;

public class Cons extends List{
	public T car;	// RXZ car 
	public T cdr;	// RXZ cdr 
	
	/**@Cons RXgN^ @*/
	public Cons() { this(Null.Nil, Null.Nil); }
	public Cons(T car, T cdr) {
		this.car = car;
		this.cdr = cdr;
	}

	/** Cons ̃VACY */
	public String toString() {
		StringBuilder str = new StringBuilder();
		Cons list = this;
		str.append("("); 						// Open "("
		while (true) {
			str.append(list.car.toString());	// Car 
			if (list.cdr == Null.Nil) {
				str.append(")");				// Close ")"
				break;
			} else if (list.cdr instanceof Atom) {
				str.append(" . ");				// hbg
				str.append(list.cdr.toString()); // Cdr 
				str.append(")");				// Close ")"
				break;
			} else {
				str.append(" ");				// 
				list = (Cons)(list.cdr);		//  Cdr 
			}
		}
		return str.toString();
	}	
}